% This function projects on bounds

function y = ACOPFsimBounds(x, parConstr)

% Parameters:

%  x         - point to project, it must be a row vector
%  parConstr - cell array with two elements: parConstr{1} is double array with the lower bound ...
%              and parConstr{2} is double array with the upper bound

n=size(parConstr{1});
if n(1) > 1
    y=max(parConstr{1}',x);
else
    y=max(parConstr{1},x);
end
n=size(parConstr{2});
if n(1) > 1
    y=min(parConstr{2}',y);
else
    y=min(parConstr{2},y);
end
    
end

