%% Global search approach

clear;
close all
clc
%% load power system data
%temp2


%pfdatainput
% Power flow data input, build Y matrix


% % Input Data File 
% [file,pathname] = uigetfile('*networkdata.xls*','Select Network Data Spreadsheet File');
% 
% if (pathname == 0),
%     error('You Must Select A Valid Data File')
% end
% 
% S=file;          % Name of the File that we need to read

S='4BusCase_networkdata.xlsx';
file ='4BusCase_networkdata.xlsx';
pathname = '/Users/sondrefharbo/OneDrive - NTNU/Prosjektoppgaver og Mastere/3 Master Optimering/OptACOPFKodeSommer/';

fprintf(' Case ID: %s \n',file);


[Parameter_data, Parameter_Character_Data] = xlsread(S, 'Parameters');
[bus, Character_Data] = xlsread(S, 'BusData');

[gen, Character_Data] = xlsread(S, 'GenData');
% Gets data for each gen bus of:  busnr	Pg	Qg	Qmax	Qmin	Vg	MVABase	status	Pmax	Pmin

[branch, Character_Data] = xlsread(S, 'BranchData');
[area, Character_Data] = xlsread(S, 'AreaData');
[areanamedata, areaname] = xlsread(S, 'AreaName');
[gencost_inputdata, Character_Data] = xlsread(S, 'GenCostData');
[Pd, Character_Data] = xlsread(S, 'Pd');
[Qd, Character_Data] = xlsread(S, 'Qd');
[Econs, Character_Data] = xlsread(S, 'Econs');
% [EconsColumn, Character_Data] = xlsread(S, 'EconsColumn');
% 

baseMVA                    = 100; %MVA
baseKV                     = 110; %KV
casemult                   = 1;
%varlimit                   = cell2mat(Parameter_Character_Data(5,2));
powerflow_tolerance        = 1.0000e-03;

% if SOC approach
%SOC = SOC * casemult/baseMVA;


numbus = 4;
numline = 6;
numgen = 4;
numarea = 1;
N=1; %timesteps per simulation

Line_flow_limits2=1;
[numbus,N] = size(bus);
[numline,N] = size(branch);
[numgen,N] = size(gen);
[numarea,N] = size(area);


% numbus
% numline
% numgen
% numarea

Bustype = zeros(1,numbus);
Bustype_start = zeros(1,numbus);

for ibus = 1:numbus
   Bustype(ibus)= ' ';
end

Pload = zeros(1,numbus);
Qload = zeros(1,numbus);
Vmax = zeros(1,numbus);
Vmin = zeros(1,numbus);

frombus = zeros(1,numline);
tobus = zeros(1,numline);
R = zeros(1,numline);
X = zeros(1,numline);
Bcap = zeros(1,numline);
flowmax = zeros(1,numline);
BranchStatus = zeros(1,numline);
Vsched = zeros(1,numgen);
Pgen = zeros(1,numgen);
Qgen = zeros(1,numgen);
Pmax = zeros(1,numgen);
Pmin = zeros(1,numgen);
Qmax = zeros(1,numgen);
Qmin = zeros(1,numgen);
genbus = zeros(1,numgen);
busgen = zeros(1,numbus);
original_genbus = zeros(1,numgen);

for ibus = 1:numbus
      bustype_number = bus(ibus,2);
   if bustype_number == 1 
     Bustype(ibus) = 'L';
  end  
  if bustype_number == 2 
     Bustype(ibus) = 'G';
  end  
  if bustype_number == 3 
     Bustype(ibus) = 'S';
     refbus = ibus;
  end  
   Bustype_start(ibus) = Bustype(ibus);
   Pload(ibus) = bus(ibus,3)* casemult/baseMVA;
   Qload(ibus) = bus(ibus,4)* casemult/baseMVA;
   Vmax(ibus) = bus(ibus,12);
   Vmin(ibus) = bus(ibus,13);
end

% Pload
% Qload
% Vmax
% Vmin
for igen = 1:numgen
   ibus = gen(igen,1);
   genbus(igen) = ibus;
   busgen(ibus) = igen;
   original_genbus(igen) = ibus;
   Pgen(igen) = gen(igen,2)* casemult/baseMVA;
   Qgen(igen) = gen(igen,3)* casemult/baseMVA;
   Pmax(igen) = gen(igen,9)/baseMVA;
   Pmin(igen) = gen(igen,10)/baseMVA;
   Qmax(igen) = gen(igen,4)/baseMVA;
   Qmin(igen) = gen(igen,5)/baseMVA;
   %if varlimit == 'N'
   %   Qmax(igen) = 99.;
    %  Qmin(igen) = -99.;
   %end
   Vsched(igen) = gen(igen,6);
end


%%
% This matrix should be updated later,
% I do first simualtion to just check how my integration would be


%1
Pload=Pd(:,1)'* casemult/baseMVA;
Qload=Qd(:,1)'* casemult/baseMVA;

% %2
% Pload2=Pd(:,2)'* casemult/baseMVA;
% Qload2=Qd(:,2)'* casemult/baseMVA;
% 
% %3
% Pload3=Pd(:,3)'* casemult/baseMVA;
% Qload3=Qd(:,3)'* casemult/baseMVA;
% 
% %4
% Pload4=Pd(:,4)'* casemult/baseMVA;
% Qload4=Qd(:,4)'* casemult/baseMVA;

% %5
% Pload5=Pd(:,5)'* casemult/baseMVA;
% Qload5=Qd(:,5)'* casemult/baseMVA;
% 
% %6
% Pload6=Pd(:,6)'* casemult/baseMVA;
% Qload6=Qd(:,6)'* casemult/baseMVA;
% 
% %7
% Pload7=Pd(:,7)'* casemult/baseMVA;
% Qload7=Qd(:,7)'* casemult/baseMVA;
% 
% %8
% Pload8=Pd(:,8)'* casemult/baseMVA;
% Qload8=Qd(:,8)'* casemult/baseMVA;
% 
% %9
% Pload9=Pd(:,9)'* casemult/baseMVA;
% Qload9=Qd(:,9)'* casemult/baseMVA;
% 
% %10
% Pload10=Pd(:,10)'* casemult/baseMVA;
% Qload10=Qd(:,10)'* casemult/baseMVA;
% 
% %11
% Pload11=Pd(:,11)'* casemult/baseMVA;
% Qload11=Qd(:,11)'* casemult/baseMVA;
% 
% %12
% Pload12=Pd(:,12)'* casemult/baseMVA;
% Qload12=Qd(:,12)'* casemult/baseMVA;
% 
% %13
% Pload13=Pd(:,13)'* casemult/baseMVA;
% Qload13=Qd(:,13)'* casemult/baseMVA;
% 
% %14
% Pload14=Pd(:,14)'* casemult/baseMVA;
% Qload14=Qd(:,14)'* casemult/baseMVA;
% 
% %15
% Pload15=Pd(:,15)'* casemult/baseMVA;
% Qload15=Qd(:,15)'* casemult/baseMVA;
% 
% %16
% Pload16=Pd(:,16)'* casemult/baseMVA;
% Qload16=Qd(:,16)'* casemult/baseMVA;

% %17
% Pload17=Pd(:,17)'* casemult/baseMVA;
% Qload17=Qd(:,17)'* casemult/baseMVA;
% 
% %18
% Pload18=Pd(:,18)'* casemult/baseMVA;
% Qload18=Qd(:,18)'* casemult/baseMVA;
% 
% %19
% Pload19=Pd(:,19)'* casemult/baseMVA;
% Qload19=Qd(:,19)'* casemult/baseMVA;
% 
% %20
% Pload20=Pd(:,20)'* casemult/baseMVA;
% Qload20=Qd(:,20)'* casemult/baseMVA;
% 
% %21
% Pload21=Pd(:,21)'* casemult/baseMVA;
% Qload21=Qd(:,21)'* casemult/baseMVA;
% 
% %22
% Pload22=Pd(:,22)'* casemult/baseMVA;
% Qload22=Qd(:,22)'* casemult/baseMVA;
% 
% %23
% Pload23=Pd(:,23)'* casemult/baseMVA;
% Qload23=Qd(:,23)'* casemult/baseMVA;
% 
% %24
% Pload24=Pd(:,24)'* casemult/baseMVA;
% Qload24=Qd(:,24)'* casemult/baseMVA;
% 
% %%

for iline = 1:numline
   frombus(iline) = branch(iline,1);
   tobus(iline)   = branch(iline,2);
   R(iline)       = branch(iline,3);
   X(iline)       = branch(iline,4);
   Bcap(iline)    = branch(iline,5);
   flowmax(iline) = branch(iline,6);
   BranchStatus(iline) = branch(iline,11);
end
Y = zeros(numbus,numbus);
for iline = 1:numline
    if BranchStatus(iline) == 1
        Y(frombus(iline),tobus(iline)) = Y(frombus(iline),tobus(iline))-1/(R(iline)+sqrt(-1)*X(iline));
        Y(tobus(iline),frombus(iline)) = Y(tobus(iline),frombus(iline))-1/(R(iline)+sqrt(-1)*X(iline));
    end
end
for ibus = 1:numbus
    Y(ibus,ibus) = -sum(Y(ibus,:));
end
for iline = 1:numline
    if BranchStatus(iline) == 1
        Y(frombus(iline),frombus(iline)) = Y(frombus(iline),frombus(iline))+sqrt(-1)*Bcap(iline)/2;
        Y(tobus(iline),tobus(iline)) = Y(tobus(iline),tobus(iline))+sqrt(-1)*Bcap(iline)/2;
    end
end

G=real(Y);
B=imag(Y);

%Init voltage and angle Variables
%v = ones(1,numbus);
%angle = zeros(1,numbus);
v = bus(:,8);
angle = bus(:,9)*(pi/180);
for igen = 1:numgen
    ibus = genbus(igen);
    v(ibus) = Vsched(igen);
end

nbus = numbus;                % Number of buss
ncircuits = numline;               % Number of Interfaces between buss


for iline = 1:numline
   fbus(iline) = frombus(iline);
   tbus(iline) = tobus(iline);
   xckt(iline) = X(iline);
   flowmax_perckt(iline) = flowmax(iline);
   monitor_circuit(iline) = BranchStatus(iline);
end

% end of temp2

%% Total number of varibles in 1 hour for 9 bus
% 1 theta1
% 2 theta2
% 3 theta3
% 4 theta4
% 5 V_1
% 6 V_2
% 7 V_3
% 8 V_4
% 9 P_1
% 10 P_2
% 11 P_3
% 12 P_4
% 13 Q_1
% 14 Q_2
% 15 Q_3
% 16 Q_4

    num_var = 16;
    
    
        f = zeros(num_var,1);
    f2= zeros(num_var,1);

    
             
    
    %% calculate bounds due to limits for generator Pgen, Qgen, and bus V
    %ok to set varible. But to remove, i need to update Aqe etc
    delta_limits_upper = zeros(num_var,1);
    delta_limits_lower = zeros(num_var,1);
    delta_limits_upper(1)=0;
    delta_limits_lower(1)=0;
    for i=2:numbus
        delta_limits_upper(i)=pi;
        delta_limits_lower(i)=-pi;
    end
    
    
    for i=numbus+1:2*numbus
        delta_limits_upper(i,1) = (Vmax(ibus));
        delta_limits_lower(i,1) = (Vmin(ibus));
    end    
    
        
    
    
    for igen = 2*numbus+1:numgen+2*numbus
        delta_limits_upper(igen) = Pmax(igen-2*numbus) ;
        delta_limits_lower(igen) = Pmin(igen-2*numbus) ;
        delta_limits_upper(igen+numgen) = Qmax(igen-2*numbus) ;
        delta_limits_lower(igen+numgen) = Qmin(igen-2*numbus);
    end
    
%delta_limits_lower(25) = 0;
%delta_limits_upper(25) = 0.5;

%delta_limits_lower(26) = 0;
%delta_limits_upper(26) = 0.5;
    
    Lb=delta_limits_lower;
    Ub=delta_limits_upper;
    x0=Lb+(Ub-Lb)/2;
    x0(isnan(x0))=0;
    
%%

%% Linear Equality matrix which are Storage equations
%SOC0=0.5*Pmax(3);


  beq=zeros(size(Pd,2),1);
  %beq(1)=SOC0;
  Aeq=zeros(size(Pd,2),size(Pd,2)*num_var);
  Aeq_s=zeros(1,2*num_var);
  %Aeq(1,21) =  1;
  %Aeq(1,num_var*size(Pd,2)-1) =  1;
  %Aeq(1,25) = -0.85;
  %Aeq(1,26) = +0.95;
  
  %Aeq_s(1,47) =  1;
  %Aeq_s(1,21) = -1;
  
  % charge and discharge efficiencies
  %Aeq_s(1,51) = -0.85;
  %Aeq_s(1,52) =  0.95;

  
  j=1; 
     for i=2:size(Pd,2)
        
        
        Aeq(i,j:i*num_var) = Aeq_s;
        j=j+num_var;
       
     end
    


%% for wind gen
 
windMean=30;
rRange = 0.5;

%Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange
Pw_observed=30;

%Pw is observation of wind energy
%Pw = Pw_observed;
gen(3,2) = Pw_observed;
gen(3,9) = Pw_observed;
gen(3,10) = Pw_observed
Lb(11) = Pw_observed/baseMVA;
Ub(11) = Pw_observed/baseMVA;
x0(11) = Pw_observed/baseMVA;

%Pb_feed=80+windMean-100;
%Pd(2) = 40;
% 
% 
% x_new =
% 
%          0
%    -0.0649
%    -0.0310
%    -0.0674
%     1.1000
%     0.9309
%     0.9999
%     0.9000
%     0.9170
%          0
%     0.3000
%          0
%     0.2757
%          0
%          0
%          0
% 
% 
% fval =
% 
%    6.8402e+03


% Pd(2) = 25
% x_new =
% 
%          0
%    -0.1020
%    -0.0430
%    -0.0795
%     1.1000
%     0.9000
%     0.9972
%     0.9000
%     0.9717
%          0
%     0.3000
%          0
%     0.2284
%          0
%          0
%          0
% 
% 
% fval =
% 
%    1.4741e+04


%Pd(2) = 40
% x_new =
% 
%          0
%    -0.1301
%    -0.0510
%    -0.0863
%     1.1000
%     0.9000
%     1.0093
%     0.9127
%     0.9218
%          0
%     0.3000
%          0
%     0.1328
%          0
%          0
%          0
% 
% 
% fval =
% 
%    7.4236e+03

%Pload
%Qb = -Ql-Qw-Qg_leastcost;
%Qb = 0;

% TotEnBatMax = 50;
% TotEnBat= TotEnBatMax/2;
% if (Lb(10)<(TotEnBat-TotEnBatMax))
% Lb(10) = TotEnBat-TotEnBatMax
% end
% if(Ub(10)>TotEnBat)
% Ub(10) = TotEnBat
% end
% x0(10) = (Lb(10)+Ub(10))/2;
 

%% gen min
% tester om det m? bikkes over for ? bli bedre
 
% Pmin(1) = (sum(Pd) - Pw_observed)/baseMVA
% gen(1,10) = Pmin(1)*baseMVA;
% Lb(9) = Pmin(1);
% Ub(9) = Pmin(1);
% x0(9) = Pmin(1);

% x0(9) = (sum(Pd) - Pw_observed)*1.15/baseMVA

 
 
 %% Run the Main section
 %%
 % Non-linear Equality and inequality Constrains
 ineq=@(x)nonLinConACOPFgeneral(x, Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs);
%ineq=@(x)nonLinConACOPFgeneral(x, Pd, Qd,baseMVA, bus, gen,Y,branch, num_var);

%%
% Objective function
fCost=@(x)ACOPFgeneralObjectFun(x, num_var, gencost_inputdata, baseMVA);
%fCost=@(x)0;
%%
%Set Fmincon options
% options = optimoptions('fmincon','Display','iter-detailed','MaxIter',1000,...
%     'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-30);

options = optimoptions('fmincon','Display','iter-detailed','MaxIter',1000,...
    'MaxFunEvals',600000,'TolCon',1e-20,'TolX',1e-15);

% options = optimoptions('fmincon','Display','iter-detailed','MaxIter',1000,...
%     'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-30,'Diagnostics','on','PlotFcn',{@optimplotx,...
%     @optimplotfval,@optimplotconstrviolation,@optimplotstepsize,@optimplotfirstorderopt});

% options = optimoptions('fmincon','Display','iter-detailed','MaxIter',1000,...
%     'MaxFunEvals',600000,'TolCon',1e-15,'TolX',1e-30,'DiffMinChange',.1);


% 
opts = optimoptions(@fmincon,'Algorithm','interior-point');
problem = createOptimProblem('fmincon','objective',...
 fCost,'x0',x0,'lb',Lb,'ub',Ub,'nonlcon',ineq,'options',opts);
gs = GlobalSearch;

tic
[x_new,fval] = run(gs,problem);
toc

% tic
% [x_new,fval,exitflag,output]=patternsearch(fCost,x0,[],[],Aeq,beq,Lb,Ub,ineq);
% toc

% tic
% nvars = length(x0);
% [x_new,fval,exitflag,output]=ga(fCost,nvars,x0,[],[],Aeq,beq,Lb,Ub,ineq);
% %x = ga(fitnessfcn,nvars,A,b,Aeq,beq,LB,UB,nonlcon)
% toc

%tic
%[x_new,fval,exitflag,output,lambda,grad,hessian] = fmincon(fCost,x0,[],[],Aeq,beq,Lb,Ub,ineq,options);
%toc

x_new
fval
[ineq2, ceq]= nonLinConACOPFgeneral(x_new,Pd,Qd,baseMVA, bus, gen,bus,branch, num_var, Econs)

% Objective function -temp4


%%  x_new is result
    %update control variable values
% 1 theta1
% 2 theta2
% 3 theta3
% 4 theta4
% 5 V_1
% 6 V_2
% 7 V_3
% 8 V_4
% 9 P_1
% 10 P_2
% 11 P_3
% 12 P_4
% 13 Q_1
% 14 Q_2
% 15 Q_3
% 16 Q_4

%     gen1      = zeros(1,length(x_new)/num_var);
%     gen2      = zeros(1,length(x_new)/num_var);
%     gen3      = zeros(1,length(x_new)/num_var);
%     gen4      = zeros(1,length(x_new)/num_var);
%     Ploa1     = zeros(1,length(x_new)/num_var);
%     Ploa2     = zeros(1,length(x_new)/num_var);
%     Ploa3     = zeros(1,length(x_new)/num_var);
%     Ploa4     = zeros(1,length(x_new)/num_var);
    
%     Pgen1      = x_new(9)*baseMVA;
%     Pgen2      = x_new(10)*baseMVA;
%     Pgen3      = x_new(11)*baseMVA;
%     Pgen4      = x_new(12)*baseMVA;
    
    %% ----- evaluate constraints -----
    %first display resulting V and angle
    v_out = x_new(5:8)*baseKV
    angle_out = x_new(1:4)*(pi/180)
     
%     %evaluate
%     Vm_out = x_new(5:8);
%     Va_out = x_new(1:4);
%     
%     % reconstruct V
%     V = Vm_out .* exp(1j * Va_out);
%     % evaluate power flow equations
%     [Ybus, Yf, Yt] = makeYbus(baseMVA, bus, branch);
%     Sbus = makeSbus(baseMVA, bus, gen)
%     %resulteing injections
%     S = V .* conj(Ybus * V)*baseMVA
    %diff is ceq
    DiffPowerFlow = [ceq(1:4) ceq(5:8)]*baseMVA
%% Find generated power
    Pgen      = x_new(9:12)*baseMVA;
    Qgen      = x_new(13:16)*baseMVA;
    
%     Ploa1     = Pd(1);
%     Ploa2     = Pd(2);
%     Ploa3     = Pd(3);
%     Ploa4     = Pd(4);
    
%     
%     for i=1:length(x_new)/num_var
%         State_ofC(i)= x_new(21+(i-1)*26)*baseMVA;
%         gen1(i)=x_new(19+(i-1)*26)*baseMVA;
%         gen2(i)=x_new(20+(i-1)*26)*baseMVA;
%         charge(i)=x_new(25+(i-1)*26)*baseMVA;
%         discharge(i)=x_new(26+(i-1)*26)*baseMVA;
%         Ploa1(i)=Pd(5,i);
%         Ploa2(i)=Pd(7,i);
%         Ploa3(i)=Pd(9,i);
%     end

figure('Name','Generator results','Numbertitle','off');
c_gen = categorical({'gen1','gen2','gen3','gen4'});
gen_vals = [Pgen Qgen]
bar(c_gen,gen_vals);
xlabel('Generator')
ylabel('Generated power')
legend('Active power, P [MW]','Reactive power, Q [MVAr]')
title('Results for the generators')

figure('Name','Load demand','Numbertitle','off');
% c_load = categorical({'P1','P2','P3','P4'});
% Ploads = [Ploa1 Ploa2 Ploa3 Ploa4]
c_load = categorical({'1','2','3','4'});
Ploads = [Pd Qd]
bar(c_load,Ploads)
xlabel('Bus number')
ylabel('Load values')
legend('Active power, P [MW]','Reactive power, Q [MVAr]')
title('Demand for the bus loads')

powerBal = [sum(Pgen) sum(Pd)]
