function [y,grad,exitFlag,NewState] = SimulateACOPF_Opt_v03_2(x,parFun, modeFlag,randFlag, State)

%% before from TrySimulate

%Which ACOPF case?
%ACOPFcase = 2; % 9BusCase

%TotEnBatMax = 50;
%TotEnBat0 = TotEnBatMax/2;

%How may timesteps?
%T=24; %1,4,24


% T = 1.000;

%windMean= ones(1,24)*100;
%rRange = 0.25;

%used to calc g and w_reaised
%batteryMinMax = ones(1,24)*35; %??

% x tries to find how much battery to store
%x0 = [100	90	80	70	60	40	-20	-50	-80	-70	-40	-30	-30	-30	-50	-70	-60	-50	0	50	70	80	90	100];
%x0=80+windMean-100;


%parConstWithBat = {[-batteryMinMax] [+batteryMinMax] TotEnBatMax
%TotEnBat0}; %cant be used here


% 1.2 Setting SQG parameters
%parFun={ACOPFcase T rRange TotEnBatMax};

%% Inintializing




%persistent Pw_observed
persistent T windProjection windMean rRange TotEnBatMax TotEnBat NumberOfIterations counter % problem data and observations must be persistent

%parameters for the ACOPF solution, to be loaded once
persistent Pd Qd Pg Qg baseMVA bus gen Y branch num_var Econs gencost_inputdata Vmax Vmin Pmax Pmin Qmax Qmin numbus ibus numgen


 % Initialization
 %parFun={windProjection windMean rRange};
%parFun={T windProjection windMean rRange};
%parFun={ACOPFcase T windProjection windMean rRange TotEnBatMax};
if modeFlag == -1
    T = parFun{2};
    windProjection = parFun{3};
    windMean=parFun{4};
    rRange=parFun{5};
    TotEnBatMax=parFun{6};
    NumberOfIterations = parFun{7};
    counter = 1;
    
        [Pd, Qd,Pg, Qg,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF2(parFun{1}); %parFun{1} defines ACOPF case data
    %randFlag=1;  % Have this too?
end

waitbar(counter/NumberOfIterations);
% generation of new observation of problem parameters

%if randFlag == 1  
%Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange;
%end

%% sovling ACOPF
% values = 0;
% for i=1:T
%     %Pw_guess = windProjection
% [ACOPFsolX, fval] = SimulateACOPF_v01(x(i),windProjection(i),Pw_observed);
% values = values +fval;
% end
%values = 0;
%for i=1:T
    %Pw_guess = windProjection
   % Pg = x;
      fprintf('SQG run nr %d\n',counter);
      
     %% For timestep of 1
if T ==1 
%TotEnBat= TotEnBatMax/2;
[ACOPFsolX, fval, gradACOPF] = SimulateACOPF_v03(x(1),rRange,...
    Pd(:,1), Qd(:,1),Pg(:,1), Qg(:,1),baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen);
%values = values +fval;
%end
%x= ACOPFsolX(10);  %stemmer ikke, detter er ikke batteriet brukt, det ble gitt av x forrige!
%stateVar = ACOPFsolX;
   fprintf('SQG run nr %d with Pb of %d gives %d\n',counter,x,fval);
   %fprintf('And returns : %i\n',fval)
% returning value and other
    % observation of function value

        %
        grad = gradACOPF(numbus*2+9);
        values=fval;
        
    %% for 24 timestep s        
   
   elseif T ==24
        values = 0;
        ACOPFsolXlast = 0;
        xValues = x.'
        grad = zeros(1,T);
        SOC0 = TotEnBatMax/2;
        SOC = [SOC0 x];
        plotResults = 0;
        for i=1:T
%             if(i ==1)
%               TotEnBat = TotEnBatMax; 
%             end
            %Pw_guess = windProjection
            ACOPFsolXlast = State((i-1)*36+1:(i-1)*36+36).';
        [ACOPFsolX, fval, gradACOPF] = SimulateACOPF_v03(SOC(i+1)-SOC(i),rRange,...
    Pd(:,i), Qd(:,i),Pg(:,i), Qg(:,i),baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen,...
    ACOPFsolXlast, plotResults);
        NewState((i-1)*36+1:(i-1)*36+36)=ACOPFsolX;
        %grad(i) = gradACOPF(numbus*2+2);
        %gradACOPF
        grad(i) = gradACOPF(numbus*2+1);  %can also remove the 0.1 from the excel file
        %grad(i) = gradACOPF(numbus*2+9);
       % if i>1 %blir ikke riktig dette
        %    grad(i)=grad(i)-grad(i-1);
%         else
%             grad(i)=grad(i)/2;
       % end
       
       if i == T
       RMS_gradP = sqrt(mean(grad.^2));
       grad = grad - RMS_gradP;
       %grad = grad-mean(grad); % This also produces some funny results,
       %they are not scaled according to weighting
       end
        
        
        %ACOPFsolXlast=ACOPFsolX;
        %grad(i) = gradACOPF(numbus*2+9)
%Pd(i),etc?
%remove redundant: windProjection?
        %x(i)
        %i
        %TotEnBat = TotEnBat+x(i)
        values = values + fval;
        
        [i x(i)]

        end
        %fprintf('SQG run nr %d gives Pb of %d \n',counter,x.');
   end
   %%
%    
   y=values;
   
    % obligatory assignments of output parameters
    
        %NewState=[];  % state vector is empty  %can I put stateVar here to be returned? Want to plots
        %grad=[];      % no gradient is computed
        exitFlag=0;   % normal exit

        
    counter=counter+1;
end