%may use clear if a problem
function [c, ceq] = powerflowConst(x,Ybus)
c = 0;
ceq = zeros(8,1);
%for bus 1: P1 and Q1
ceq(1) = -x(9) + x(5)*x(6)*abs(Ybus(1,2))*cos(x(1)-x(2)+angle(Ybus(1,2))) ...
               + x(5)*x(7)*abs(Ybus(1,3))*cos(x(1)-x(3)+angle(Ybus(1,3))) ...
               + x(5)*x(8)*abs(Ybus(1,4))*cos(x(1)-x(4)+angle(Ybus(1,4)));

ceq(5) = -x(13)+ x(5)*x(6)*abs(Ybus(1,2))*sin(x(1)-x(2)+angle(Ybus(1,2))) ...
               + x(5)*x(7)*abs(Ybus(1,3))*sin(x(1)-x(3)+angle(Ybus(1,3))) ...
               + x(5)*x(8)*abs(Ybus(1,4))*sin(x(1)-x(4)+angle(Ybus(1,4)));

%for bus 1: P2 and Q2
ceq(2) = -x(10)+ x(6)*x(5)*abs(Ybus(2,1))*cos(x(2)-x(1)+angle(Ybus(2,1))) ...
               + x(6)*x(7)*abs(Ybus(2,3))*cos(x(2)-x(3)+angle(Ybus(2,3))) ...
               + x(6)*x(8)*abs(Ybus(2,4))*cos(x(2)-x(4)+angle(Ybus(2,4)));

ceq(6) = -x(14)+ x(6)*x(5)*abs(Ybus(2,1))*sin(x(2)-x(1)+angle(Ybus(2,1))) ...
               + x(6)*x(7)*abs(Ybus(2,3))*sin(x(2)-x(3)+angle(Ybus(2,3))) ...
               + x(6)*x(8)*abs(Ybus(2,4))*sin(x(2)-x(4)+angle(Ybus(2,4)));

%for bus 3: P3 and Q3
ceq(3) = -x(11)+ x(7)*x(5)*abs(Ybus(3,1))*cos(x(3)-x(1)+angle(Ybus(3,1))) ...
               + x(7)*x(6)*abs(Ybus(3,2))*cos(x(3)-x(2)+angle(Ybus(3,2))) ...
               + x(7)*x(8)*abs(Ybus(3,4))*cos(x(3)-x(4)+angle(Ybus(3,4)));

ceq(7) = -x(15)+ x(7)*x(5)*abs(Ybus(3,1))*sin(x(3)-x(1)+angle(Ybus(3,1))) ...
               + x(7)*x(6)*abs(Ybus(3,2))*sin(x(3)-x(2)+angle(Ybus(3,2))) ...
               + x(7)*x(8)*abs(Ybus(3,4))*sin(x(3)-x(4)+angle(Ybus(3,4)));

%for bus 4: P4 and Q4
ceq(4) = -x(12)+ x(8)*x(5)*abs(Ybus(4,1))*cos(x(4)-x(1)+angle(Ybus(4,1))) ...
               + x(8)*x(6)*abs(Ybus(4,2))*cos(x(4)-x(2)+angle(Ybus(4,2))) ...
               + x(8)*x(7)*abs(Ybus(4,3))*cos(x(4)-x(3)+angle(Ybus(4,3)));

ceq(8) = -x(16)+ x(8)*x(5)*abs(Ybus(4,1))*sin(x(4)-x(1)+angle(Ybus(4,1))) ...
               + x(8)*x(6)*abs(Ybus(4,2))*sin(x(4)-x(2)+angle(Ybus(4,2))) ...
               + x(8)*x(7)*abs(Ybus(4,3))*sin(x(4)-x(3)+angle(Ybus(4,3)));
end
