function [y,grad,exitFlag,NewState] = SimulateACOPF_Opt_v02_2(x,parFun, modeFlag,randFlag, State)

%parFun={T windProjection windMean rRange};

%windProjection = [30   40   20   30];

%x=[Pg_t1  Pg_t2 Pg_t3 Pg_t4];
%x0=[80 90 70 80];
%parConstr = {[50 50 50 50] [110 110 110 110]};


%windProjection = [30];

%x=[Pg];
%x0=[80];
%parConstr = {[50] [110]};


%used to calc g and w_reaised
%windProjection = 30;


%% Inintializing




%persistent Pw_observed
persistent T windProjection windMean rRange TotEnBatMax TotEnBat NumberOfIterations counter % problem data and observations must be persistent

%parameters for the ACOPF solution, to be loaded once
persistent Pd Qd baseMVA bus gen Y branch num_var Econs gencost_inputdata Vmax Vmin Pmax Pmin Qmax Qmin numbus ibus numgen


 % Initialization
 %parFun={windProjection windMean rRange};
%parFun={T windProjection windMean rRange};
if modeFlag == -1
    T = parFun{2};
    windProjection = parFun{3};
    windMean=parFun{4};
    rRange=parFun{5}; 
    TotEnBatMax=parFun{6};
    NumberOfIterations = parFun{7};
    counter = 1;
    
        [Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF(parFun{1}); %parFun{1} defines ACOPF case data
    %randFlag=1;
end

waitbar(counter/(NumberOfIterations));


% generation of new observation of problem parameters

%if randFlag == 1  
%Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange;
%end

%% sovling ACOPF
% values = 0;
% for i=1:T
%     %Pw_guess = windProjection
% [ACOPFsolX, fval] = SimulateACOPF_v01(x(i),windProjection(i),Pw_observed);
% values = values +fval;
% end
%values = 0;
%for i=1:T
    %Pw_guess = windProjection
   % Pg = x;
      fprintf('SQG run nr %d\n',counter);
      
     %% For timestep of 1
if T ==1 
TotEnBat= TotEnBatMax/2;
[ACOPFsolX, fval,gradACOPF] = SimulateACOPF_v02_1(x,windProjection,windMean,rRange,...
    Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen,...
    TotEnBat, TotEnBatMax);
grad = gradACOPF(numbus*2+2);
%values = values +fval;
%end
%x= ACOPFsolX(10);  %stemmer ikke, detter er ikke batteriet brukt, det ble gitt av x forrige!
%stateVar = ACOPFsolX;
   fprintf('SQG run nr %d with Pb of %d gives %d\n',counter,x,fval);
   %fprintf('And returns : %i\n',fval)
% returning value and other
    % observation of function value

        %
        values=fval;
        
    %% for 4 timestep s        
   
   elseif T ==4
        values = 0;
        ACOPFsolXlast=0;
        grad = zeros(1,T);
        SOC0 = TotEnBatMax/2;
        SOC = [SOC0 x];
        %xValues = x.'
        for i=1:T
%             if(i ==1)
%               TotEnBat = TotEnBatMax; 
%             end
            %Pw_guess = windProjection
            ACOPFsolXlast = State((i-1)*16+1:(i-1)*16+16).';
        [ACOPFsolX, fval, gradACOPF] = SimulateACOPF_v02_1(SOC(i+1)-SOC(i),windProjection(i),windMean(i),rRange,...
    Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
    gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen,...
    TotEnBat, TotEnBatMax,...
    ACOPFsolXlast);
        NewState((i-1)*16+1:(i-1)*16+16)=ACOPFsolX;
        grad(i) = gradACOPF(numbus*2+1);
        
        
       if i == T
       RMS_gradP = sqrt(mean(grad.^2));
       grad = grad - RMS_gradP;
       %grad = grad-mean(grad);
       end
       
% SOME OUPUT....
% gradS =
% 
%    1.0e+04 *
% 
%    -2.5916   -0.6114   -0.3530    3.5559
% 
% 
% ans =
% 
%    29.9910   25.4759   48.3322   49.9835
% 
% 
% charging =
% 
%     4.9910   -4.5151   22.8563    1.6513
        
        %x(i)
        %i
        %TotEnBat = TotEnBat+x(i)
        values = values + fval;
        
        %[i x(i)]

        end % T
        fprintf('SQG run nr %d gives Pb of %d \n',counter,x.');
   end
   %%
%    
   y=values;
   
    % obligatory assignments of output parameters
    
        %NewState=[];  % state vector is empty  %can I put stateVar here to be returned? Want to plots
        grad=[];      % no gradient is computed
        exitFlag=0;   % normal exit

    counter=counter+1;
end