% Constraint Initialization and Setup






% this file has to be modified later

fprintf(' Constraint Setup \n');
fprintf(' ');
fprintf('  Bus    Pgen         Qgen          Vgen   \n')
% v = bus(:,8)';
% angle = bus(:,9)*(pi/180);
VarLimTol = 0.001;
VoltageLimTol = 0.005;
PflowLimTol = 1.0;
for igen = 1:numgen
    print_flag = 0;
    Plimit_ind = '  ';
    Qlimit_ind = '  ';
    Vlimit_ind = '  ';
    ibus = genbus(igen);
         
    if abs ( Pgen(igen) - Pmax(igen) ) < VarLimTol
            Plimit_ind = 'UL';
    elseif abs ( Pgen(igen) - Pmin(igen) ) < VarLimTol
            Plimit_ind = 'LL';
    end
    
    if abs ( Qgen(igen) - Qmax(igen) ) < VarLimTol
            Qlimit_ind = 'UL';
    elseif abs ( Qgen(igen) - Qmin(igen) ) < VarLimTol
            Qlimit_ind = 'LL';
    end
    % force scheduled voltages on generators to be within voltage limits at
    % bus
    if Vsched(igen) > Vmax(ibus)
        Vsched(igen) = Vmax(ibus);
        v(ibus) = Vmax(ibus);
        fprintf(' Warning, Gen scheduled voltage changed to meet Vmax limit on bus %3d \n',ibus)
        print_flag = 1;
    end
    
    if Vsched(igen) < Vmin(ibus)
        Vsched(igen) = Vmin(ibus);
        v(ibus) = Vmin(ibus);
        fprintf(' Warning, Gen scheduled voltage changed to meet Vmin limit on bus %3d \n',ibus)
        print_flag = 1;
    end
    
    if abs ( Vsched(igen) - Vmax(ibus) ) < VoltageLimTol
        Vlimit_ind = 'UL';
    elseif abs ( Vsched(igen) - Vmin(ibus) ) < VoltageLimTol
        Vlimit_ind = 'LL';
    end
    
    if print_flag == 1
       fprintf(' %3d     %7.2f %s    %7.2f%s    %5.4f%s \n', ibus, Pgen(igen)*baseMVA, ...
                        Plimit_ind, Qgen(igen)*baseMVA, Qlimit_ind, Vsched(igen), Vlimit_ind );
    end
end

